#pragma once

// Physics
#include "NxPhysics.h"

/**
 * class which contains useful static drawing function for some actors.
 */
class ActorDrawing
{
public:
	ActorDrawing(void);
	~ActorDrawing(void);

	static void drawPlane(NxShape* plane);

	/**
	 * draw a sphere shape
	 * @param sphere must be an instance of a NxSphereShape
	 */
	static void drawSphere(NxShape* sphere);

	/**
	 * draw a box shape.
	 * @param shape must be an instance of a NxBoxShape
	 */
	static void drawBox(NxShape* box);

	/**
	 * draw a capsule shape
	 * @param capsule must be an instance of a NxCapsuleShape
	 */
	static void drawCapsule(NxShape* capsule);

	static void drawMesh(NxShape* mesh);

	static NxMaterialIndex materialIce, materialRock, materialMud, materialGrass, materialSun, materialViolet, materialDefault;

	static void setMaterial(NxMaterialIndex material);

};
