#include "digitalnumber.h"

DigitalNumber::DigitalNumber(void) {
}
DigitalNumber::DigitalNumber(float width, float height) {
	this->width = width;
	this->height = height;

	float b = width/10.0f;

	points1[0] = b        ; points1[1] = b            ;
	points2[0] = b        ; points2[1] = height/2.0f  ;
	points3[0] = b        ; points3[1] = height-b     ;
	points4[0] = width-b  ; points4[1] = b            ;
	points5[0] = width-b  ; points5[1] = height/2.0f  ;
	points6[0] = width-b  ; points6[1] = height-b     ;

	dimX[0] = width-2.0f*b; dimX[1] = 1.5f*b        ;
	dimY[0] = 1.5f*b      ; dimY[1] = height/2.0f-b ;
}
DigitalNumber::~DigitalNumber(void) {
}
void DigitalNumber::draw(int value) {
	switch(value) {
		case 0:
			draw0();
			break;
		case 1:
			draw1();
			break;
		case 2:
			draw2();
			break;
		case 3:
			draw3();
			break;
		case 4:
			draw4();
			break;
		case 5:
			draw5();
			break;
		case 6:
			draw6();
			break;
		case 7:
			draw7();
			break;
		case 8:
			draw8();
			break;
		case 9:
			draw9();
			break;
	}
}
void DigitalNumber::drawXLine(float start[]) {
	// dim: first value is in x dir, second value is in y dir
	float r = dimX[1]/2.0f;
	glRectf(start[0], start[1] - r, start[0] + dimX[0], start[1] + r);
}
void DigitalNumber::drawYLine(float start[]) {
	// dim: first value is in x dir, second value is in y dir
	float r = dimY[0]/2.0f;
	glRectf(start[0] - r, start[1], start[0] + r, start[1] + dimY[1]);
}
void DigitalNumber::draw0() {
	drawYLine(points1);
	drawYLine(points2);
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points1);
	drawXLine(points3);
}
void DigitalNumber::draw1() {
	drawYLine(points4);
	drawYLine(points5);
}
void DigitalNumber::draw2() {
	drawYLine(points5);
	drawYLine(points1);

	drawXLine(points1);
	drawXLine(points2);
	drawXLine(points3);
}
void DigitalNumber::draw3() {
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points1);
	drawXLine(points2);
	drawXLine(points3);
}
void DigitalNumber::draw4() {
	drawYLine(points2);
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points2);
}
void DigitalNumber::draw5() {
	drawYLine(points2);
	drawYLine(points4);

	drawXLine(points1);
	drawXLine(points2);
	drawXLine(points3);
}
void DigitalNumber::draw6() {
	drawYLine(points1);
	drawYLine(points2);
	drawYLine(points4);

	drawXLine(points1);
	drawXLine(points2);
}
void DigitalNumber::draw7() {
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points3);
}
void DigitalNumber::draw8() {
	drawYLine(points1);
	drawYLine(points2);
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points1);
	drawXLine(points2);
	drawXLine(points3);
}
void DigitalNumber::draw9() {
	drawYLine(points2);
	drawYLine(points4);
	drawYLine(points5);

	drawXLine(points1);
	drawXLine(points2);
	drawXLine(points3);
}
