#pragma once

// Physics
#include "NxPhysics.h"

#include "trianglemesh.h"
#include "plane.h"
#include "digitalnumber.h"
#include "player.h"


class Environment
{
	// fields
private:
	NxPhysicsSDK *physicsSDK;
	NxScene *scene;

	TriangleMesh *cone;
	Plane *ground;
	DigitalNumber numbers[6];

private:
	void createScoreBox();
	void createSpotlights();
	void createFloor();
	void createPiles();
	void createCapsules();
	void createCone();
	void createNails();
	void createConeTriangleFan();

public:
	Environment(NxPhysicsSDK *gPhysicsSDK, NxScene *gScene);
	~Environment(void);

	static NxReal radius;
	static NxReal height;

	static GLuint textureNails[1];

public:
	void drawScore(Player *players);

};
