
#include "globe.h"

#include "texturehelper.h"

#include "environment.h"

#include "sphere.h"


#define ballRadius 0.05

GLuint Globe::globeTexture[1];
Camera* Globe::camera;

Globe::Globe(GLuint playerNumber, NxActorDesc actorDesc)
{
	this->playerNumber = playerNumber;
	this->actorDesc = actorDesc;

}

Globe::~Globe(void)
{
}

void Globe::initialize(Camera* camera) {
	// prepare texture for the globes
	TextureHelper::loadGLTextures(&Globe::globeTexture[0], "football.bmp");
	Globe::camera = camera;
}

void Globe::createGlobe(NxScene* gScene, Player *players) {

	// choose player number, it is either 0 or 1
	GLuint playerNumber = (int)((1.0*rand()/RAND_MAX)+0.5);

	Player player = players[playerNumber];

	// create sphere
	Sphere *sphere = new Sphere(player.getNumber(), player.getTexture());

	// create shape desc
	NxSphereShapeDesc sphereDesc;
	sphereDesc.radius= ballRadius;
	sphereDesc.userData = sphere;

	// create actor
	NxActorDesc actorDesc;
	actorDesc.shapes.pushBack(&sphereDesc);
	actorDesc.density = 100;

	// put it on the border of the cone
	NxReal r = Environment::radius;
	NxReal h = Environment::height;

	double camx = camera->getFirstAxis();
	double camz = camera->getSecondAxis();

	// maybe use randomness
	//actor.globalPose.t = *(new NxVec3(-1+(int)(3.0*rand()/RAND_MAX),2,-1+(int)(3.0*rand()/RAND_MAX))); // um (0,100,0) rum
	actorDesc.globalPose.t = *(new NxVec3(-camx*0.95, h + 0.3, -camz*0.95));

	// make it dynamic
	NxBodyDesc bodyDesc;
	bodyDesc.linearVelocity = *(new NxVec3(0,0,0));
	actorDesc.body = &bodyDesc;

	// add it to the scene
	NxActor *actor = gScene->createActor(actorDesc);
	//sphere->actor = actor;
}
