#pragma once

// OpenGL
#define NOMINMAX
#include <windows.h>
#include <GL/gl.h>
//#include <GL/glut.h>
//#include <GL/glu.h>							// Header File For The GLu32 Library
//#include <GL/glaux.h>							// Header File For The GLaux Library

// Physics
#include "NxPhysics.h"

#include "camera.h"

#include "player.h"

class Globe
{

public:
	Globe(GLuint playerNumber, NxActorDesc actorDesc);
	~Globe(void);

	GLuint playerNumber;
	NxActorDesc actorDesc;


	// static members they are used to create globes

	/*
	 * init textures
	 */
	static void initialize(Camera *camera);

	/*
	 * member to hold the texture
	 */
	static GLuint globeTexture[];

	/*
	 * member to hold the texture
	 */
	static Camera* camera;

	/*
	 * create a globe at the border of the environment cone
	 */
	static void createGlobe(NxScene* gScene, Player *players);

};
