
#include "texturehelper.h"

#include <stdio.h>							// Header File For Standard Input/Output ( NEW )

TextureHelper::TextureHelper(void)
{
}

TextureHelper::~TextureHelper(void)
{
}

/*
 *
 */
AUX_RGBImageRec* TextureHelper::loadBMP(char *filename) {
	FILE *file=NULL;						// File Handle
	if (!filename)							// Make Sure A Filename Was Given
	{
		return NULL;						// If Not Return NULL
	}
	file=fopen(filename,"r");				// Check To See If The File Exists
	if (file)								// Does The File Exist?
	{
		fclose(file);						// Close The Handle
		return auxDIBImageLoad(filename);	// Load The Bitmap And Return A Pointer
	}
	return NULL;							// If Load Failed Return NULL
}

/*
 * Load Bitmaps And Convert To Textures
 */
int TextureHelper::loadGLTextures(GLuint *texture, char *filename) {
	int status=FALSE;							// Status Indicator
	AUX_RGBImageRec *textureImage[1];					// Create Storage Space For The Texture
	memset(textureImage,0,sizeof(void *)*1);				// Set The Pointer To NULL
	
	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	if (textureImage[0]=loadBMP(filename))
	{
		status=TRUE;							// Set The Status To TRUE
		glGenTextures(1, &texture[0]);					// Create The Texture

		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		// Generate The Texture
		glTexImage2D(GL_TEXTURE_2D, 0, 3, textureImage[0]->sizeX, 
			textureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, textureImage[0]->data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
	}
	if (textureImage[0]) {							// If Texture Exists
		if (textureImage[0]->data) {					// If Texture Image Exists
			free(textureImage[0]->data);				// Free The Texture Image Memory
		}
		free(textureImage[0]);						// Free The Image Structure
	}
	return status;								// Return The Status
}
