#include <stdio.h>

#include "triggercallback.h"
#include "sphere.h"
#include "player.h"
#include "environment.h"

extern Player players[2];
extern NxActor * shootsToRemove[10];
extern NxActorDesc * newNails[10];

#define nailLength 0.2
#define nailRadius 0.01

TriggerCallback::TriggerCallback(void)
{
}

TriggerCallback::~TriggerCallback(void)
{
}

void TriggerCallback::setScene(NxScene *gScene) {
	this->gScene = gScene;
}

void TriggerCallback::onTrigger(NxShape& triggerShape, NxShape& otherShape, NxTriggerFlag status) {

	// trigger shapes are:
	// -the floor of the environment and
	// -nails on the fly

	if(status & NX_TRIGGER_ON_ENTER) {
		if(triggerShape.getType() == NX_SHAPE_PLANE) {
			if(otherShape.getType() == NX_SHAPE_SPHERE) {
				Sphere & sphere = *(Sphere*)otherShape.userData;
				GLuint playerNumber = sphere.playerNumber;

				players[playerNumber].score++;
				//printf("%d has %d points\n", playerNumber, players[playerNumber].score);

				// actors are removed if they have a y pos of less then zero
				//gScene->releaseActor(triggerShape.getActor());
				//gScene->releaseActor(otherShape.getActor());
			}
		} else if(triggerShape.getType() == NX_SHAPE_BOX) {
			if(otherShape.getType() == NX_SHAPE_MESH) {



				NxReal x = triggerShape.getGlobalPose().t.x;
				NxReal y = triggerShape.getGlobalPose().t.y;
				NxReal z = triggerShape.getGlobalPose().t.z;

				NxCapsuleShapeDesc *capsuleShape = new NxCapsuleShapeDesc();
				capsuleShape->height = nailLength;
				capsuleShape->radius = nailRadius;
				capsuleShape->userData = &Environment::textureNails[0];

				for(int i=0; i<10; i++) {
					if(newNails[i] == 0) {
						NxActorDesc *capsule = new NxActorDesc();
						capsule->shapes.pushBack(capsuleShape);
						capsule->globalPose.t = *(new NxVec3(x, y, z));

						newNails[i] = capsule;
						break;
					}
				}

				for(int i=0; i<10; i++) {
					if(shootsToRemove[i] == 0) {
						shootsToRemove[i] = &(triggerShape.getActor());
						break;
					}
				}
				//gScene->createActor(capsule);

				//triggerShape.getActor().setGlobalPosition(NxVec3(0.0, -10.0, 0.0));
			}
		}
	}
}
